# coding: utf-8

"""
    Conekta API

    Conekta sdk  # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist

class TokenResponseCheckout(BaseModel):
    """
    TokenResponseCheckout
    """
    allowed_payment_methods: Optional[conlist(StrictStr)] = None
    can_not_expire: Optional[StrictBool] = Field(None, description="Indicates if the checkout can not expire.")
    emails_sent: Optional[StrictInt] = None
    exclude_card_networks: Optional[conlist(StrictStr)] = None
    expires_at: Optional[StrictInt] = Field(None, description="Date and time when the checkout expires.")
    failure_url: Optional[StrictStr] = Field(None, description="URL to redirect the customer to if the payment process fails.")
    force_3ds_flow: Optional[StrictBool] = Field(None, description="Indicates if the checkout forces the 3DS flow.")
    id: Optional[StrictStr] = None
    livemode: Optional[StrictBool] = None
    metadata: Optional[Dict[str, Any]] = None
    monthly_installments_enabled: Optional[StrictBool] = Field(None, description="Indicates if the checkout allows monthly installments.")
    monthly_installments_options: Optional[conlist(StrictInt)] = Field(None, description="List of monthly installments options.")
    name: Optional[StrictStr] = None
    needs_shipping_contact: Optional[StrictBool] = None
    object: Optional[StrictStr] = Field(None, description="Indicates the type of object, in this case checkout.")
    on_demand_enabled: Optional[StrictBool] = Field(None, description="Indicates if the checkout allows on demand payments.")
    paid_payments_count: Optional[StrictInt] = Field(None, description="Number of payments that have been paid.")
    recurrent: Optional[StrictBool] = Field(None, description="Indicates if the checkout is recurrent.")
    sms_sent: Optional[StrictInt] = None
    starts_at: Optional[StrictInt] = Field(None, description="Date and time when the checkout starts.")
    status: Optional[StrictStr] = Field(None, description="Status of the checkout.")
    success_url: Optional[StrictStr] = Field(None, description="URL to redirect the customer to after the payment process is completed.")
    type: Optional[StrictStr] = Field(None, description="Type of checkout.")
    __properties = ["allowed_payment_methods", "can_not_expire", "emails_sent", "exclude_card_networks", "expires_at", "failure_url", "force_3ds_flow", "id", "livemode", "metadata", "monthly_installments_enabled", "monthly_installments_options", "name", "needs_shipping_contact", "object", "on_demand_enabled", "paid_payments_count", "recurrent", "sms_sent", "starts_at", "status", "success_url", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TokenResponseCheckout:
        """Create an instance of TokenResponseCheckout from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TokenResponseCheckout:
        """Create an instance of TokenResponseCheckout from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TokenResponseCheckout.parse_obj(obj)

        _obj = TokenResponseCheckout.parse_obj({
            "allowed_payment_methods": obj.get("allowed_payment_methods"),
            "can_not_expire": obj.get("can_not_expire"),
            "emails_sent": obj.get("emails_sent"),
            "exclude_card_networks": obj.get("exclude_card_networks"),
            "expires_at": obj.get("expires_at"),
            "failure_url": obj.get("failure_url"),
            "force_3ds_flow": obj.get("force_3ds_flow"),
            "id": obj.get("id"),
            "livemode": obj.get("livemode"),
            "metadata": obj.get("metadata"),
            "monthly_installments_enabled": obj.get("monthly_installments_enabled"),
            "monthly_installments_options": obj.get("monthly_installments_options"),
            "name": obj.get("name"),
            "needs_shipping_contact": obj.get("needs_shipping_contact"),
            "object": obj.get("object"),
            "on_demand_enabled": obj.get("on_demand_enabled"),
            "paid_payments_count": obj.get("paid_payments_count"),
            "recurrent": obj.get("recurrent"),
            "sms_sent": obj.get("sms_sent"),
            "starts_at": obj.get("starts_at"),
            "status": obj.get("status"),
            "success_url": obj.get("success_url"),
            "type": obj.get("type")
        })
        return _obj

